/**
 * Class to implement a linked list of Turtle-like characters.
 * (Maybe "agents"?)
 **/
public class AgentNode extends LLNode {
  /**
   * The Turtle being held
   **/
  private Turtle myTurtle;
  
  /** Two constructors: One for creating the head of the list
   * , with no agent 
  **/
  public AgentNode() {super();}
  
  /**
   * One constructor for creating a node with an agent
   **/
  public AgentNode(Turtle agent){
    super();
    this.setAgent(agent);
  }
  
  /** 
   * Make a printable form
   **/
  public String toString() {
    return "AgentNode with agent ("+myTurtle+") and next: "+
      (AgentNode) getNext();
  }
  
  /**
   * Setter for the turtle
   **/
  public void setAgent(Turtle agent){
    myTurtle = agent;
  }
  
  /**
   * Getter for the turtle
   **/
  public Turtle getAgent(){return myTurtle;}
  
  /**
   * Remove the node where this turtle is found.
   **/
  public void remove(Turtle myTurtle) {
    // Assume we're calling on the head
    AgentNode head = this;
    AgentNode current = (AgentNode) this.getNext();
    
    while (current != null) {
      if (current.getAgent() == myTurtle)
      {// If found the turtle, remove that node
        head.remove(current);
      }
      
      current = (AgentNode) current.getNext();
    }
  }
}
