public class AnimatedPositionedScene {
  
  /**
   * A FrameSequence for storing the frames
   **/
  FrameSequence frames;
  
  /**
   * We'll need to keep track 
   * of the elements of the scene
   **/
  PositionedSceneElement tree1, tree2, tree3, house, doggy, doggyflip;
  
  public void setUp(){
    frames = new FrameSequence("C:/Temp/");
    
    Picture p = null; // Use this to fill elements
    
    p = new Picture(FileChooser.getMediaPath("tree-blue.jpg"));
    tree1 = new PositionedSceneElement(p);
    
    p = new Picture(FileChooser.getMediaPath("tree-blue.jpg"));
    tree2 = new PositionedSceneElement(p);

    p = new Picture(FileChooser.getMediaPath("tree-blue.jpg"));
    tree3 = new PositionedSceneElement(p);
    
    p = new Picture(FileChooser.getMediaPath("house-blue.jpg"));
    house = new PositionedSceneElement(p);
    
    p = new Picture(FileChooser.getMediaPath("dog-blue.jpg"));
    doggy = new PositionedSceneElement(p);
    doggyflip = new PositionedSceneElement(p.flip());
  }
  
  public void make(){
    frames.show();
    
    // First frame
    Picture bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.setNext(doggy); doggy.setNext(tree2); tree2.setNext(tree3);
    tree3.setNext(house);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);
    
    // Dog moving right
    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggy);
    tree2.insertAfter(doggy);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);

    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggy);
    tree3.insertAfter(doggy);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);

    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggy);
    house.insertAfter(doggy);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);
    
    //Dog moving left
    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggy);
    house.insertAfter(doggyflip);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);
  
    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggyflip);
    tree3.insertAfter(doggyflip);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);

    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggyflip);
    tree2.insertAfter(doggyflip);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);

    bg = new Picture(FileChooser.getMediaPath("jungle.jpg"));
    tree1.remove(doggyflip);
    tree1.insertAfter(doggyflip);
    tree1.drawFromMeOn(bg);
    frames.addFrame(bg);

  }
  
  public void replay(){
    frames.replay(100); //3 frames per second
  }
}
