/**
 * BirdAgents use the bird character JPEGs
 **/
public class BirdAgent extends Agent{
  
  public static Picture bird1, bird2, bird3, bird4, bird5, bird6;
  
  /**
   * Set up the birds
   **/
  public void init(Simulation thisSim){
    if (bird1 == null) {
      // Do we have the bird characters defined yet?
      bird1 = new Picture(FileChooser.getMediaPath("bird1.jpg"));
      bird2 = new Picture(FileChooser.getMediaPath("bird2.jpg"));
      bird3 = new Picture(FileChooser.getMediaPath("bird3.jpg"));
      bird4 = new Picture(FileChooser.getMediaPath("bird4.jpg"));
      bird5 = new Picture(FileChooser.getMediaPath("bird5.jpg"));
      bird6 = new Picture(FileChooser.getMediaPath("bird6.jpg"));
   }
    // Start out with myPict as bird1
    myPict = bird1;
    
    // Do the normal initializations
    super.init(thisSim);
    
    // Move all the birds to the far right corner
    this.setPenDown(false);
    this.moveTo(600,400);
    
    // Set speed to relatively slow
    this.setSpeed(40);

  }
  
  /**
   * act(t) For first 20 steps, walk toward the egg,
   * +/- 30 degrees.
   * Then walk AWAY from the egg, and with MORE wandering (panic).
   **/
  public void act(int t){
    // First, handle motion
    if (t <= 20) {
      // Tell it that this really is a BirdSimulation
      BirdSimulation mySim = (BirdSimulation) simulation;
      // which has an egg
      this.turnToFace(mySim.egg);
      this.turn(randNumGen.nextInt(60)-30);
      forward(randNumGen.nextInt(speed));
    } else {
      // Run away!!
      this.turnToFace(640,480); // Far right corner
      this.turn(randNumGen.nextInt(80)-40);
      forward(randNumGen.nextInt(speed));
    }
    
    // Next, set a new character
    int cell = randNumGen.nextInt(6)+1; // 0 to 5, + 1 => 1 to 6
    switch (cell) {
      case 1: 
        myPict = bird1; // this.drop(bird1); 
        break;
      case 2: 
        myPict = bird2; //this.drop(bird2); 
        break;
      case 3: 
        myPict = bird3; //this.drop(bird3); 
        break;
      case 4: 
        myPict = bird4; //this.drop(bird4); 
        break;
      case 5: 
        myPict = bird5; //this.drop(bird5); 
        break;
      case 6: 
        myPict = bird6; //this.drop(bird6); 
        break;
    } // end switch
  } // end act
  
  ////////////////////////////// Constructors ////////////////////////
  // Copy this section AS-IS into subclasses, but rename Agent to 
  // Your class.
  
  /**
   * Constructor that takes the model display (the original
   * position will be randomly assigned)
   * @param modelDisplayer thing that displays the model
   * @param thisSim my simulation
   */
  public BirdAgent (ModelDisplay modelDisplayer,Simulation thisSim)
  {
    super(randNumGen.nextInt(modelDisplayer.getWidth()),
          randNumGen.nextInt(modelDisplayer.getHeight()),
          modelDisplayer, thisSim);
  }
  
  /** Constructor that takes the x and y and a model
   * display to draw it on
   * @param x the starting x position
   * @param y the starting y position
   * @param modelDisplayer the thing that displays the model
   * @param thisSim my simulation
   */
  public BirdAgent (int x, int y, ModelDisplay modelDisplayer, 
               Simulation thisSim) 
  {
    // let the parent constructor handle it
    super(x,y,modelDisplayer,thisSim);
  }
} // end BirdAgent class

