/** 
 * DSSimulation is a Discrete Event Simulation
 * Instead of asking each agent to act(),
 * we simply process events from a queue.
 **/
public class DSSimulation extends Simulation {
  /** Queue for Events */
  protected EventQueue events;
  
  /** current time */
  public double now;
  
  ///// Constructor ////
  public DSSimulation(){
    // Call our superclass's constructor
    super();
    now = 0.0;
    events = new EventQueue();
  }
  
  //// Methods ////
  
  /** getTime -- return what time it is now. */
  public double getTime() {return now;}
  
  /** addEvent -- add an event to the queue */
  public void addEvent(SimEvent newEvent) {
    events.add(newEvent);
  }
  
  /**
   * Run, by simply 
   **/
  /*public void run()
  {
    // For storing the current agent
    Agent current = null;
    
    // Set up the simulation
    this.setUp();
    
    // loop for a set number of timesteps 
    for (int t = 0; t < timeRange; t++)
    {
      // loop through all the agents, and have them
      // act()
      for (int index=0; index < agents.size(); index++) {
        current = (Agent) agents.get(index);
        if (!current.blocked) { // NEW for resources
          current.act(t);} // pass in timestep
      }
     // Could separate acting from updating...
      
      // repaint the world to show the movement
      // IF there is a world
      if (world != null) {
        world.repaint();}
      
      // Do the end of step processing
      this.endStep(t);
    
      // Wait for one second
      //Thread.sleep(1000);
    }
    
  }*/

}
