/** 
 * FactorySimulation -- set up the whole simulation,
 * including creation of the Trucks and Distributors.
 **/
public class FactorySimulation extends DESimulation {
  
  private Resource product;
  
  /**
   * Accessor for factory
   **/
  public Resource getProduct(){return product;}
  
  public void setUp(){
    // Let the world be setup
    super.setUp();
    // Give the world a reasonable background
    world.setPicture(new Picture(
                   FileChooser.getMediaPath("EconomyBackground.jpg")));
    
    // Create a warehouse resource
    product = new Resource(); //Track product
    
    // Create three trucks
    Truck myTruck = null;
    for (int i=0; i<3; i++){
      myTruck = new Truck(world,this);
      myTruck.setName("Truck: "+i);}

    // Create five Distributors
    Distributor sales = null;
    for (int i=0; i<5; i++){
      sales = new Distributor(world,this);
      sales.setName("Distributor: "+i);}
  }
}
