// Cassy Romano
// gtg507q@mail.gatech.edu
/** 
 * EggAgent -- big scary egg that sits there until t=30, 
 * then emerges as a monster!
 **/
public class NBDAgent extends Agent {
  
  public static Picture hunter1, blank;
  
  /**
   * To initialize, set it up as the Egg in the upper lefthand corner
   **/
  public void init(Simulation thisSim){
    if (hunter1 == null) { //Initialize
      hunter1 = new Picture(FileChooser.getMediaPath("hunter.jpg"));
      blank = new Picture(FileChooser.getMediaPath("blank.jpg"));
    }
    // Start out as egg1
    myPict = hunter1;
    
    // Normal initialization
    super.init(thisSim);
    
    // Move the egg up to the left hand corner
    this.moveTo(20,20);
  }
  
  /**
   * To act, just drop the Egg for 15 steps,
   * then be the eyes opened for five steps,
   * then be the eyes switching back-and-forth
   **/
  public void act(int t) {    
    if (t < 10) {
      myPict = blank;}
    
    else if (t>= 10){
      myPict = hunter1;
      this.forward(randNumGen.nextInt(5));
      }
  
  } // end act()
  
        ////////////////////////////// Constructors ////////////////////////
        // Copy this section AS-IS into subclasses, but rename Agent to 
        // Your class.
  
  /**
   * Constructor that takes the model display (the original
   * position will be randomly assigned)
   * @param modelDisplayer thing that displays the model
   * @param thisSim my simulation
   */
  public NBDAgent (ModelDisplay modelDisplayer,Simulation thisSim)
  {
    super(randNumGen.nextInt(modelDisplayer.getWidth()),
          randNumGen.nextInt(modelDisplayer.getHeight()),
          modelDisplayer, thisSim);
  }
  
  /** Constructor that takes the x and y and a model
   * display to draw it on
   * @param x the starting x position
   * @param y the starting y position
   * @param modelDisplayer the thing that displays the model
   * @param thisSim my simulation
   */
  public NBDAgent (int x, int y, ModelDisplay modelDisplayer, 
               Simulation thisSim) 
  {
    // let the parent constructor handle it
    super(x,y,modelDisplayer,thisSim);
  }
}
