import java.awt.Color; // Color for colorizing
import java.util.LinkedList;

/**
 * PoliticalAgent -- Red or Blue Stater as a subclass of Agent
 **/
public class PoliticalAgent extends Agent {

  // Red or Blue
  public Color politics;
  public int stuckness;
  
  public static LinkedList redParty = new LinkedList();
  public static LinkedList blueParty = new LinkedList();
  
  /**
   * Initialize
   **/
  public void init(Simulation thisSim){
    // Do the normal initializations
    super.init(thisSim);
    
    // Don't need to see the trail
    setPenDown(false);

    // Speed is 100
    speed = 100;
    stuckness = 0;

  }
  
  /**
   * Set politics
   **/
  public void setPolitics(Color pref){
    System.out.println("I am "+politics+" converting to "+pref);
    
    if (pref == Color.red) {
      blueParty.remove(this);
      redParty.add(this);
      this.politics = pref;}
    else {
      blueParty.add(this);
      redParty.remove(this);
      this.politics = pref;
    }
    this.setColor(pref);
    stuckness = 3;
    
  }
  
  /**
   * How a PoliticalAgent acts
   **/
  public void act()
  {
    this.stuckness--;
    
    // What are the number of blues and red near me?
    int numBlue = countInRange(30,blueParty);
    int numRed = countInRange(30,redParty);
    /*System.out.println("I am "+politics+" and near me are red:"
                         +numRed+" and blue:"+numBlue);*/
    if (politics==Color.red){
      // If I'm red, and there are more blue than red near me, convert
      if ((numBlue > numRed) && (this.stuckness <= 0)){
        setPolitics(Color.blue);}
    }
    if (politics==Color.blue){
      // If I'm blue, and there are more red than blue near me, convert
      if ((numRed > numBlue) && (this.stuckness <= 0)) {
      setPolitics(Color.red);}
    }

    // Run the normal act() -- wander aimlessly
    super.act();
    
    // But don't let them wander too far!
    // Let them mix only in the middle
    if (politics==Color.red) {
      if (this.getXPos() > 400) { // Did I go too far right?
        this.moveTo(200,this.getYPos());}
    }
     if (politics==Color.blue) {
      if (this.getXPos() < 200) { // Did I go too far left?
        this.moveTo(400,this.getYPos());}
     }
   
  }

    ////////////////////////////// Constructors ////////////////////////
  // Copy this section AS-IS into subclasses, but rename Agent to 
  // Your class.
  
  /**
   * Constructor that takes the model display (the original
   * position will be randomly assigned)
   * @param modelDisplayer thing that displays the model
   * @param thisSim my simulation
   */
  public PoliticalAgent (ModelDisplay modelDisplayer,Simulation thisSim)
  {
    super(randNumGen.nextInt(modelDisplayer.getWidth()),
          randNumGen.nextInt(modelDisplayer.getHeight()),
          modelDisplayer, thisSim);
  }
  
  /** Constructor that takes the x and y and a model
   * display to draw it on
   * @param x the starting x position
   * @param y the starting y position
   * @param modelDisplayer the thing that displays the model
   * @param thisSim my simulation
   */
  public PoliticalAgent (int x, int y, ModelDisplay modelDisplayer, 
               Simulation thisSim) 
  {
    // let the parent constructor handle it
    super(x,y,modelDisplayer,thisSim);
  }
  

}
