import java.awt.Color;

/**
 * PoliticalSimulation -- using the Simulation class
 **/
public class PoliticalSimulation extends Simulation {

  /**
   * lineForFile -- write out number of each party 
   **/
  public String lineForFile(){

    return (new Integer(PoliticalAgent.redParty.size())).toString()+"\t"+
      (new Integer(PoliticalAgent.blueParty.size())).toString();
  }
  
  /**
   * EndStep, count the number of each
   **/
  public void endStep(int t){
    super.endStep(t);
    
    System.out.println("Red: "+PoliticalAgent.redParty.size()+" Blue: "+
                       PoliticalAgent.blueParty.size());
  }
  
  /** 
   * Fill the world with 60 persons
   **/
  public void setUp(){
    // Let the world be set up
    super.setUp();

    PoliticalAgent moi;
    
    // 60 people
    for (int num = 0; num < 60; num++) {
      moi = new PoliticalAgent(world,this);
      // First 30 are red
      if (num < 30) {
        moi.politics = Color.red;
        moi.moveTo(100,100);
        PoliticalAgent.redParty.add(moi);
      }
      else {
        moi.politics = Color.blue;
        moi.moveTo(500,100);
        PoliticalAgent.blueParty.add(moi);
      }
      moi.setColor(moi.politics);

    } // for loop
    
  } // setUp()
  
}
