/**
 * SimulationEvent (SimEvent) -- an event that occurs in a simulation,
 * like a truck arriving at a factory, or a salesperson leaving the
 * market
 **/
public class SimEvent{
  /// Fields ///
  /** When does this event occur? */
  public double time;
  
  /** 
   * To whom does it occur? Who should be informed when it occurred? 
   **/
  public DEAgent whom;
  
  /** What is the event?  We'll use integers to represent the meaning
   * of the event -- the "message" of the event.
   * Each agent will know the meaning of the integer for themselves.
   **/
  public int message;
  
  /// Accessors ///
  public double getTime(){return time;}
  public void setTime(double mytime){time = mytime;}
  public int getMessage() {return message;}
  public void setMessage(int newMsg){message = newMsg;}
  public DEAgent getAgent() {return whom;}
  
  /// Constructor ///
  public SimEvent(DEAgent moi, double scheduledTime, int meaning){
    whom = moi;
    time = scheduledTime;
    message = meaning;
  }
  
  public SimEvent(){
    whom = null;
    message = 0;
  }
  
  /// Methods ///
  
}