/*
 * SoundNode is a class representing a sound in a sound tree.
 **/
public class SoundNode extends CollectableNode {
  /**
   * The sound I'm associated with
   **/
  Sound mySound;
  
  /*
   * Make me with this sound
   * @param sound the Sound I'm associated with
   **/
  public SoundNode(Sound sound){
    super(); // Call superclass constructor
    mySound = sound;
  }

  /**
   * Method to return a string with informaiton 
   * about this node
   */
  public String toString() 
  {
    return "SoundNode (with sound: "+mySound+" and next: "+next+")";
  }

  /** 
   * Collect all the sounds from me on,
   * recursively.
   **/
  public Sound collect(){
    SoundNode nextNode;
    if (this.getNext() == null)
    {return mySound;}
    else
    {nextNode = (SoundNode) this.getNext();
      return mySound.append(nextNode.collect());}
  }
  
  /**
   * Collect and process after
   **/
  public Sound collectAfter(){
    if (this.getNext() == null)
    {return mySound;}
    else
    {return mySound.append((this.getNext()).collectAfter());}
  }
    /**
   * Collect swapped: Doesn't change in SoundNode
   **/
  public Sound collectSwap(){
    if (this.getNext() == null)
    {return mySound;}
    else
    {return mySound.append((this.getNext()).collectAfter());}
  }
}
