public class SoundTreeExample {

  ScaleBranch scaledBranch; // Needed between methods
  
  SoundBranch root;
  public SoundBranch root(){return root;}
  
  public void setUp() {
    Sound clap = new Sound(FileChooser.getMediaPath("clap-q.wav"));
    Sound chirp = new Sound(FileChooser.getMediaPath("chirp-2.wav"));
    Sound rest = new Sound(FileChooser.getMediaPath("rest-1.wav"));
    Sound snap = new Sound(FileChooser.getMediaPath("snap-tenth.wav"));
    Sound clink = new Sound(FileChooser.getMediaPath("clink-tenth.wav"));
    Sound clave = new Sound(FileChooser.getMediaPath("clave-twentieth.wav"));
    Sound gong = new Sound(FileChooser.getMediaPath("gongb-2.wav"));
    Sound bassoon = new Sound(FileChooser.getMediaPath("bassoon-c4.wav")); 
    Sound is = new Sound(FileChooser.getMediaPath("is.wav")); 
    Sound aah = new Sound(FileChooser.getMediaPath("aah.wav")); 
   
    root = new SoundBranch();
    SoundNode sn;
    
    SoundBranch branch1 = new SoundBranch();
    sn = new SoundNode(clap.append(rest).append(snap));
    branch1.addChild(sn);
    sn = new SoundNode(aah.append(snap).append(rest));
    branch1.addChild(sn);
 
    scaledBranch = new ScaleBranch(1.0);
    sn = new SoundNode(clink.append(clave).append(gong));
    scaledBranch.addChild(sn);
    sn = new SoundNode(is.append(chirp).append(clap));
    scaledBranch.addChild(sn);

    SoundBranch branch2 = new SoundBranch();
    sn = new SoundNode(clap.append(snap).append(snap));
    branch2.addChild(sn);
    sn = new SoundNode(bassoon.append(snap).append(clap));
    branch2.addChild(sn);

    root.addChild(branch1); 
    root.addChild(scaledBranch);
    root.addChild(branch2);
  }

    public void setUp2() {
      Sound clap = new Sound(FileChooser.getMediaPath("clap-q.wav"));
      Sound chirp = new Sound(FileChooser.getMediaPath("chirp-2.wav"));
      Sound rest = new Sound(FileChooser.getMediaPath("rest-1.wav"));
      Sound snap = new Sound(FileChooser.getMediaPath("snap-tenth.wav"));
      Sound clink = new Sound(FileChooser.getMediaPath("clink-tenth.wav"));
      Sound clave = new Sound(FileChooser.getMediaPath("clave-twentieth.wav"));
      Sound gong = new Sound(FileChooser.getMediaPath("gongb-2.wav"));
      Sound guzdial = new Sound(FileChooser.getMediaPath("guzdial.wav"));
      Sound is = new Sound(FileChooser.getMediaPath("is.wav"));
      
      root = new SoundBranch();
      SoundNode sn;
      
      SoundBranch branch1 = new SoundBranch();
      sn = new SoundNode(guzdial.append(is).append(snap));
      branch1.addChild(sn);
      sn = new SoundNode(clink.append(snap).append(clave));
      branch1.addChild(sn);
      sn = new SoundNode(guzdial.append(is).append(is));
      branch1.addChild(sn);
      root.addChild(branch1);
      
      scaledBranch = new ScaleBranch(2.0);
      sn = new SoundNode(clink.append(clave).append(gong));
      scaledBranch.addChild(sn);
      sn = new SoundNode(rest.append(chirp).append(clap));
      scaledBranch.addChild(sn);
      root.addChild(scaledBranch);
      
      scaledBranch = new ScaleBranch(0.5);
      sn = new SoundNode(guzdial.append(is).append(gong));
      scaledBranch.addChild(sn);
      branch1.addChild(scaledBranch);
      
      SoundBranch branch2 = new SoundBranch();
      sn = new SoundNode(clap.append(clap).append(clave));
      branch2.addChild(sn);
      sn = new SoundNode(snap.append(snap).append(clave));
      branch2.addChild(sn);
      sn = new SoundNode(snap.append(snap).append(clave));
      branch2.addChild(sn);
      root.addChild(branch2);
      
      root.playFromMeOn();
  }


  public void play(){
    root.playFromMeOn();
  }

  public void playScaled(double factor){
    scaledBranch.setFactor(factor);
    root.playFromMeOn();
  }

  public void playAfter(){
    root.collectAfter().play();
  }
  
  public void playSwapped(){
    root.collectSwap().play();
  }
}
